\\ Copyright 2018 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0)
default(strictargs,1)

\\ 4pq = b(b+1)

\\ non-primitive
\\ 8778, 10296, 13530

is_triangular(n) =
{
  n <<= 1;
  my(t=sqrtint(n));
  n==t*(t+1);
}
{
  my(v=vector(10000));
  for(i=1,#v,
     my(T=i*(i+1)/2); if(T>#v, break); v[T]=1);
  v==vector(#v,n,is_triangular(n)) || error();
}

{
  my(limit=1000000);
  b=limit;
  B=b*(b+1)/2;
  printf("to B=%d  %e\n", B, B);

  for(b=1,limit,
     bb = b*(b+1);
     bitand(bb,3)==0 || next;
     pq=bb >> 2;
     fordiv(bb,q,
           p=bb/q;
           p>q || break;
           if(bitand(p,1) && bitand(q,1), next);  \\ not both odd
           pp=p^2;
           qq=q^2;
           A=pp-qq;
           is_triangular(A) || next;
           C=pp+qq;
           is_triangular(C) || next;
           print("pq="p","q);
     ));

}
quit
