#!/usr/bin/perl -w

# Copyright 2013, 2014, 2020 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


# Print tikz D,Q points as dots, with d=p-q.

use strict;

use FindBin;
use lib $FindBin::Bin;
use MyPrintwrap ':all';
use MyTriples 'pq_acceptable';


my $d_limit = 15;

print "    % generated by tools/$FindBin::Script\n";

$Printwrap = 4;
printwrap("\\fill foreach \\p in {");
$Printwrap += 2;
foreach my $d (0 .. $d_limit) {
  my $any_printed = 0;
  foreach my $q (0 .. $d_limit) {
    # d=p-q   p=d+q
    my $p = $d+$q;
    if (pq_acceptable($p,$q)) {
      printwrap("($d,$q),");
      $any_printed = 1;
    }
  }
}
printwrap("}");
printwrap(" { \\p circle[] };\n");
print "    % end generated\n";
1;
