#!/usr/bin/perl -w

# Copyright 2013, 2014, 2020 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use strict;
use Math::PlanePath::PythagoreanTree;

use FindBin;
use lib $FindBin::Bin;
use MyPrintwrap ':all';


my $p_limit = 10;

print "    % generated by tools/$FindBin::Script\n";

my $path = Math::PlanePath::PythagoreanTree->new (coordinates => 'PQ');
my $n = $path->n_start;
my $count = 0;

$Printwrap = 4;
printwrap("\\fill foreach \\p in {");
$Printwrap += 2;
foreach my $p (0 .. $p_limit) {
  foreach my $q (0 .. $p) {
    if ($path->xy_is_visited($p,$q)) {
      my $s = $p + $q;
      my $d = $p - $q;
      printwrap("($s,$d),");
      $count++;
    }
  }
}
printwrap("}");
printwrap(" { \\p circle[] };\n");
print "    % total $count points\n";
print "    % end generated\n";
1;
